﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace ThreadExample
{
    public partial class Form1 : Form
    {
        private delegate void AddItem(XmlDocument xml);

        public Form1()
        {
            InitializeComponent();
        }

        private void populateNames_Click(object sender, EventArgs e)
        {
            // Create a new instance of the names class
            Names myNames = new Names();

            // Register the event to fire when we have the xml data
            myNames.PopulateNamesComplete += new PopulateNamesCompleteEventHandler(populateNames_Complete);

            // Start the new thread
            myNames.LoadNames();
        }

        private void populateNames_Complete(Object sender, PopulateNamesCompleteEventArgs e)
        {
            // When this thread gets called its still running in the other thread so you can't
            // access any of the UI controls on the form unless you do so through a delegate funciton
            // if you just wanted to assign a variable you can still do that without invoking
            // a delegate method.

            // I want to edit the UI though so i have to do this.
            this.Invoke(new AddItem(AddMenuItem), e.Xml);
        }

        private void AddMenuItem(XmlDocument xml)
        {
            foreach (XmlNode node in xml.SelectNodes("names/name"))
                names.Items.Add(node.InnerText);
        }
    }
}
